
#include <iostream>
#include <cstdlib>
#include "AdvancedIceSkater.h"

using namespace std;

AdvancedIceSkater::AdvancedIceSkater(int li, int col, int sp, int d, IceSkater* p):IceSkater(li, col, sp, d, p)
{
    cout << "Creating Advanced -> id: " << id << "\tline: " << line << "\tcolumn: " << column << "\tspeed: " << speed << "\tdirection: " << direction << endl;     
}

AdvancedIceSkater::~AdvancedIceSkater()
{
    cout << "Destroying Advanced -> id: " << id << "\tline: " << line << "\tcolumn: " << column << "\tspeed: " << speed << "\tdirection: " << direction << endl;     
}

void AdvancedIceSkater::skate(IceSkater***& stage, int M, int L)
{
    cout << "Advanced skates" << endl;
    
    time--;    

    int tmpl = line, tmpc = column;
    IceSkater* tempi = stage[line][column];;    
    
    if(line > M/2 && column <= L/2)//vrisketai sto kato aristera tetartimorio
    {
        if(column == 0)
            direction = 0;   
        else if(line == M)
        {
            direction = rand() % 3;
            if(direction != 0)
                direction = direction + 5;
        }
        else
            do{
                direction = rand() % 8;
            }while(direction > 0 && direction < 4);
        move(stage, M, L);
    }

    else if(line <= M/2 && column <= L/2)//vrisketai sto pano aristera tetartimorio
    {
        if(line == 0)
            direction = 2;      
        else if(column == 0)
            direction = rand() % 3;
        else
            do{
                direction = rand() % 8;
            }while(direction > 2 && direction < 6);
        move(stage, M, L);            
    }               

    else if(line <= M/2 && column > L/2)//vrisketai sto pano deksia tetartimorio
    {
        if(column == L)
            direction = 4;    
        else if(line == 0)
            direction = (rand() % 3) + 2;      
        else
            do{
                direction = rand() % 8;
            }while(direction > 4);
        move(stage, M, L);            
    }

    else if(line > M/2 && column > L/2)//vrisketai sto kato deksia tetartimorio
    {
        if(line == M)
            direction = 6;              
        else if(column == L)
            direction = (rand() % 3) + 4;     
        else
            do{
                direction = rand() % 8;
            }while(direction > 6 && direction < 2);
        move(stage, M, L);            
    }     

    stage[line][column] = tempi;
    if(stage[tmpl][tmpc] == tempi)
    {
        stage[tmpl][tmpc] = NULL;
    }
    moved = true;    
}

void AdvancedIceSkater::move(IceSkater***& stage, int M, int L)
{
    switch (direction)
    {
        case 0:
            for(int i = 0; i < speed; i++)
            {   
                line--;                
                if(stage[line][column] != NULL)
                {
                    if(stage[line][column]->hasMoved())
                    {
                        if(i+1 == speed)
                        {
                            stage[line][column]->collision(stage, M, L);
                            collision(stage, M, L);
                        }
                        else if(stage[line][column]->getDirection() == (0 || 4))
                        {
                            stage[line][column]->collision(stage, M, L);
                            collision(stage, M, L);                             
                        }
                    }
                    else if(i+1 == speed)
                    {
                        stage[line][column]->skate(stage, M, L);                        
                    }                   
                }   
                if( line == 0)
                    break;                 
            }
            break;
        case 1:
            for(int i = 0; i < speed; i++)
            {            
                line--;column++;
                if(stage[line][column] != NULL)
                {
                    if(stage[line][column]->hasMoved())
                    {
                        if(i+1 == speed)
                        {
                            stage[line][column]->collision(stage, M, L);
                            collision(stage, M, L);
                        }
                        else if(stage[line][column]->getDirection() == (1 || 5))
                        {
                            stage[line][column]->collision(stage, M, L);
                            collision(stage, M, L);                             
                        }
                    }
                    else if(i+1 == speed)
                    {
                        stage[line][column]->skate(stage, M, L);                        
                    } 
                } 
                if( line == 0 || column == L)
                    break;                 
            }            
            break;
        case 2:
            for(int i = 0; i < speed; i++)
            {              
                column++;
                if(stage[line][column] != NULL)
                {
                    if(stage[line][column]->hasMoved())
                    {
                        if(i+1 == speed)
                        {
                            stage[line][column]->collision(stage, M, L);
                            collision(stage, M, L);
                        }
                        else if(stage[line][column]->getDirection() == (2 || 6))
                        {
                            stage[line][column]->collision(stage, M, L);
                            collision(stage, M, L);                             
                        }
                    }
                    else if(i+1 == speed)
                    {
                        stage[line][column]->skate(stage, M, L);                        
                    } 
                }   
                if( column == L)
                    break;                 
            }             
            break;
        case 3:
            for(int i = 0; i < speed; i++)
            {              
                line++;column++;
                if(stage[line][column] != NULL)
                {
                    if(stage[line][column]->hasMoved())
                    {
                        if(i+1 == speed)
                        {
                            stage[line][column]->collision(stage, M, L);
                            collision(stage, M, L);
                        }
                        else if(stage[line][column]->getDirection() == (3 || 7))
                        {
                            stage[line][column]->collision(stage, M, L);
                            collision(stage, M, L);                             
                        }
                    }
                    else if(i+1 == speed)
                    {
                        stage[line][column]->skate(stage, M, L);                        
                    } 
                }  
                if( line == M || column == L)
                    break;                 
            }             
            break;
        case 4:
            for(int i = 0; i < speed; i++)
            {              
                line++;
                if(stage[line][column] != NULL)
                {
                    if(stage[line][column]->hasMoved())
                    {
                        if(i+1 == speed)
                        {
                            stage[line][column]->collision(stage, M, L);
                            collision(stage, M, L);
                        }
                        else if(stage[line][column]->getDirection() == (0 || 4))
                        {
                            stage[line][column]->collision(stage, M, L);
                            collision(stage, M, L);                             
                        }
                    }
                    else if(i+1 == speed)
                    {
                        stage[line][column]->skate(stage, M, L);                        
                    }                    
                } 
                if( line == M )
                    break;                 
            }             
            break;
        case 5:
            for(int i = 0; i < speed; i++)
            {             
                line++;column--;
                if(stage[line][column] != NULL)
                {
                    if(stage[line][column]->hasMoved())
                    {
                        if(i+1 == speed)
                        {
                            stage[line][column]->collision(stage, M, L);
                            collision(stage, M, L);
                        }
                        else if(stage[line][column]->getDirection() == (1 || 5))
                        {
                            stage[line][column]->collision(stage, M, L);
                            collision(stage, M, L);                             
                        }
                    }
                    else if(i+1 == speed)
                    {
                        stage[line][column]->skate(stage, M, L);                        
                    } 
                }     
                if( line == M || column == 0)
                    break;                 
            }              
            break;
        case 6:
            for(int i = 0; i < speed; i++)
            {            
                column--;
                if(stage[line][column] != NULL)
                {
                    if(stage[line][column]->hasMoved())
                    {
                        if(i+1 == speed)
                        {
                            stage[line][column]->collision(stage, M, L);
                            collision(stage, M, L);
                        }
                        else if(stage[line][column]->getDirection() == (6 || 2))
                        {
                            stage[line][column]->collision(stage, M, L);
                            collision(stage, M, L);                             
                        }
                    }
                    else if(i+1 == speed)
                    {
                        stage[line][column]->skate(stage, M, L);                        
                    } 
                }  
                if(column == 0)
                    break;                 
            }            
            break;
        case 7:
            for(int i = 0; i < speed; i++)
            {              
                line--;column--;
                if(stage[line][column] != NULL)
                {
                    if(stage[line][column]->hasMoved())
                    {
                        if(i+1 == speed)
                        {
                            stage[line][column]->collision(stage, M, L);
                            collision(stage, M, L);
                        }
                        else if(stage[line][column]->getDirection() == (7 || 3))
                        {
                            stage[line][column]->collision(stage, M, L);
                            collision(stage, M, L);                             
                        }
                    }
                    else if(i+1 == speed)
                    {
                        stage[line][column]->skate(stage, M, L);                        
                    } 
                }
                if(line == 0 || column == 0)
                    break;                 
            }             
            break;           
    }
}

void AdvancedIceSkater::collision(IceSkater***& stage, int M, int L)
{
    cout << "Advanced id: " << id << "\tline: " << line << "\tcolumn: " << column << "\tspeed: " << speed << "\tdirection: " << direction << endl;     
    cout << "I just overcame the situation!" << endl; 
    
    int tmpl = line, tmpc = column;
    IceSkater* tempi = stage[line][column];      
    
    if(line == 0 && column == 0)
    {
        do
        {
            line = rand() % 2;
            column = rand() % 2;
        }while(line == 0 && column == 0);
    }
    else if(line == 0 && column == L)
    {
        do
        {
            line = rand() % 2;
            column = (rand() % 2) + L-1;
        }while(line == 0 && column == L);  
    }
    else if(line == M && column == L)
    {
        do
        {
            line = (rand() % 2) + M-1;
            column = (rand() % 2) + L-1;
        }while(line == M && column == L);        
    }
    else if(line == M && column == 0)
    {
        do
        {
            line = (rand() % 2) + M-1;
            column = rand() % 2;
        }while(line == M && column == 0);        
    }
    else if(column == 0)
    {
        int templ = line;
        do
        {
            line = (rand() % 3) + line - 1;
            column = rand() % 2;
        }while(line == templ && column == 0);       
    }
    else if(column == L)
    {
        int templ = line;
        do
        {
            line = (rand() % 3) + line - 1;
            column = (rand() % 2) + L - 1;
        }while(line == templ && column == L);       
    }
    else if(line == 0)
    {
        int tempc = column;
        do
        {
            line = rand() % 2;
            column = (rand() % 3) + column - 1;
        }while(line == 0 && column == tempc);        
    }
    else if(line == M)
    {
        int tempc = column;
        do
        {
            line = (rand() % 2) + M - 1;
            column = (rand() % 3) + column - 1;
        }while(line == M && column == tempc);          
    }
    else
    {
        int templ = line;
        int tempc = column;
        do
        {
            line = (rand() % 3) + line - 1;
            column = (rand() % 3) + column - 1;
        }while(line == templ && column == tempc);        
    }
    
    if(stage[line][column] != NULL)
    {
        if(stage[line][column]->hasMoved())
        {
            stage[line][column]->collision(stage, M, L);
            collision(stage, M, L);
        }
        else
        {
            stage[line][column]->skate(stage, M, L);
        } 
    }    
    
    if(tempi != NULL)
        stage[line][column] = tempi;
    stage[tmpl][tmpc] = NULL;       
}

void AdvancedIceSkater::print()
{
    cout << " A ";
}
