
#include <iostream>
#include <cstdlib>
#include "CommonIceSkater.h"

using namespace std;

CommonIceSkater::CommonIceSkater(int li, int col, int sp, int vd, int hd, int d, IceSkater* p):IceSkater(li, col, sp, d, p)
{
    verdist = vd;
    hordist = hd;
    cout << "Creating Common -> id: " << id << "\tline: " << line << "\tcolumn: " << column << "\tspeed: " << speed
         << "\tdirection: " << direction << "\tvd: " << verdist << "\thd: " << hordist << endl;    
}

CommonIceSkater::~CommonIceSkater()
{
    cout << "Destroying Common -> id: " << id << "\tline: " << line << "\tcolumn: " << column << "\tspeed: " << speed << "\tdirection: " << direction << endl;
}

void CommonIceSkater::skate(IceSkater***& stage, int M, int L)
{
    cout << "Common skates" << endl; 
    
    time--;
    
    int tmpl = line, tmpc = column;
    IceSkater* tempi = stage[line][column];
    
    if(direction == 0)
    {
        if(line == verdist)
        {
            direction = 2;
            for(int i = 0; i < speed; i++)
            {
                column++;
                if(stage[line][column] != NULL)
                {
                    if(stage[line][column]->hasMoved())
                    {
                        if(i+1 == speed)
                        {
                            stage[line][column]->collision(stage, M, L);
                            collision(stage, M, L);
                        }
                        else if(stage[line][column]->getDirection() == (2 || 6))
                        {
                            stage[line][column]->collision(stage, M, L);
                            collision(stage, M, L);                             
                        }
                    }
                    else if(i+1 == speed)
                    {
                        stage[line][column]->skate(stage, M, L);                        
                    }
                }
                if(column == L - hordist)
                    break;
            }            
        }
        else
        {
            for(int i = 0; i < speed; i++)
            {
                line--;
                if(stage[line][column] != NULL)
                {
                    if(stage[line][column]->hasMoved())
                    {
                        if(i+1 == speed)
                        {
                            stage[line][column]->collision(stage, M, L);
                            collision(stage, M, L);
                        }
                        else if(stage[line][column]->getDirection() == (0 || 4))
                        {
                            stage[line][column]->collision(stage, M, L);
                            collision(stage, M, L);                             
                        }
                    }
                    else if(i+1 == speed)
                    {
                        stage[line][column]->skate(stage, M, L);                        
                    }
                }                
                if( line == verdist)
                    break;
            }
        }
    }
    
    else if(direction == 2)
    {
        if(column == L - hordist)
        {
            direction = 4;
            for(int i = 0; i < speed; i++)
            {
                line++;
                if(stage[line][column] != NULL)
                {
                    if(stage[line][column]->hasMoved())
                    {
                        if(i+1 == speed)
                        {
                            stage[line][column]->collision(stage, M, L);
                            collision(stage, M, L);
                        }
                        else if(stage[line][column]->getDirection() == (4 || 0))
                        {
                            stage[line][column]->collision(stage, M, L);
                            collision(stage, M, L);                             
                        }
                    }
                    else if(i+1 == speed)
                    {
                        stage[line][column]->skate(stage, M, L);                        
                    }
                }
                if(line == M - verdist)
                    break;
            }            
        }
        else
        {
            for(int i = 0; i < speed; i++)
            {
                column++;
                if(stage[line][column] != NULL)
                {
                    if(stage[line][column]->hasMoved())
                    {
                        if(i+1 == speed)
                        {
                            stage[line][column]->collision(stage, M, L);
                            collision(stage, M, L);
                        }
                        else if(stage[line][column]->getDirection() == (2 || 6))
                        {
                            stage[line][column]->collision(stage, M, L);
                            collision(stage, M, L);                             
                        }
                    }
                    else if(i+1 == speed)
                    {
                        stage[line][column]->skate(stage, M, L);                        
                    }
                }                
                if( column == L - hordist)
                    break;
            }
        }
    }   
    
    else if(direction == 4)
    {
        if(line == M - verdist)
        {
            direction = 6;
            for(int i = 0; i < speed; i++)
            {
                column--;
                if(stage[line][column] != NULL)
                {
                    if(stage[line][column]->hasMoved())
                    {
                        if(i+1 == speed)
                        {
                            stage[line][column]->collision(stage, M, L);
                            collision(stage, M, L);
                        }
                        else if(stage[line][column]->getDirection() == (2 || 6))
                        {
                            stage[line][column]->collision(stage, M, L);
                            collision(stage, M, L);                             
                        }
                    }
                    else if(i+1 == speed)
                    {
                        stage[line][column]->skate(stage, M, L);                        
                    }
                }
                if(column == hordist)
                    break;
            }            
        }
        else
        {
            for(int i = 0; i < speed; i++)
            {
                line++;
                if(stage[line][column] != NULL)
                {
                    if(stage[line][column]->hasMoved())
                    {
                        if(i+1 == speed)
                        {
                            stage[line][column]->collision(stage, M, L);
                            collision(stage, M, L);
                        }
                        else if(stage[line][column]->getDirection() == (4 || 0))
                        {
                            stage[line][column]->collision(stage, M, L);
                            collision(stage, M, L);                             
                        }
                    }
                    else if(i+1 == speed)
                    {
                        stage[line][column]->skate(stage, M, L);                        
                    }
                }                
                if( line == M - verdist)
                    break;
            }
        }
    }  
        
    else if(direction == 6)
    {
        if(column == hordist)
        {
            direction = 0;
            for(int i = 0; i < speed; i++)
            {
                line--;
                if(stage[line][column] != NULL)
                {
                    if(stage[line][column]->hasMoved())
                    {
                        if(i+1 == speed)
                        {
                            stage[line][column]->collision(stage, M, L);
                            collision(stage, M, L);
                        }
                        else if(stage[line][column]->getDirection() == (0 || 4))
                        {
                            stage[line][column]->collision(stage, M, L);
                            collision(stage, M, L);                             
                        }
                    }
                    else if(i+1 == speed)
                    {
                        stage[line][column]->skate(stage, M, L);                        
                    }
                }
                if(line == verdist)
                    break;
            }            
        }
        else
        {
            for(int i = 0; i < speed; i++)
            {
                column--;
                if(stage[line][column] != NULL)
                {
                    if(stage[line][column]->hasMoved())
                    {
                        if(i+1 == speed)
                        {
                            stage[line][column]->collision(stage, M, L);
                            collision(stage, M, L);
                        }
                        else if(stage[line][column]->getDirection() == (2 || 6))
                        {
                            stage[line][column]->collision(stage, M, L);
                            collision(stage, M, L);                             
                        }
                    }
                    else if(i+1 == speed)
                    {
                        stage[line][column]->skate(stage, M, L);                        
                    }
                }                
                if( column == hordist)
                    break;
            }
        }
    }
    
    stage[line][column] = tempi;
    if(stage[tmpl][tmpc] == tempi)
    {
        stage[tmpl][tmpc] = NULL;
    }
    moved = true;
}

void CommonIceSkater::collision(IceSkater***& stage, int M, int L)
{
    cout << "Common fell id: " << id << "\tline: " << line << "\tcolumn: " << column << "\tspeed: " << speed << "\tdirection: " << direction << endl;     
    cout << "I just fell but nice to meet you!" << endl;
    
    int tmpl = line, tmpc = column;
    IceSkater* tempi = stage[line][column];  
    
    if(line == verdist && column == hordist)
    {
        column++;
        direction = 2;
    }
    else if(line == verdist && column == L - hordist)
    {
        line++;
        direction = 4;
    }
    else if(line == M - verdist && column == L - hordist)
    {
        column--;       
        direction = 6;
    }    
    else if(line == M - verdist && column == hordist)
    {
        line--; 
        direction = 0;
    }        
    else if(column == hordist || column == L - hordist)
        (rand() % 2 == 0 ? line-- : line++);
    else if(line == verdist || line == M - verdist)
        (rand() % 2 == 0 ? column-- : column++);
    
    if(stage[line][column] != NULL)
    {
        if(stage[line][column]->hasMoved())
        {
            stage[line][column]->collision(stage, M, L);
            collision(stage, M, L);
        }
        else
        {
            stage[line][column]->skate(stage, M, L);
        } 
    }  
    
    if(tempi != NULL)
        stage[line][column] = tempi;
    stage[tmpl][tmpc] = NULL;   
}

void CommonIceSkater::print()
{
    cout << " C ";    
}
