
#ifndef ICESKATER_H
#define	ICESKATER_H

class IceSkater
{
public:

    virtual ~IceSkater();     

    virtual void skate(IceSkater***&, int, int) = 0;
    virtual void collision(IceSkater***&, int, int) = 0; 
    virtual void print() = 0;
    inline bool hasMoved(){return moved;};
    inline void setMoved(bool m){moved = m;};
    inline int getDirection(){return direction;};
    inline int getTime(){return time;};    
    
protected:    
    
    IceSkater(int, int, int, int, IceSkater*);                 
    
    int speed, time, id, line, column, direction;
    bool moved;
    IceSkater* pair;
    
private:
    
    static int base;
};

#endif	/* ICESKATER_H */

