
#include <iostream>
#include <stdlib.h>
#include "ChildIceSkater.h"

using namespace std;

ChildIceSkater::ChildIceSkater(int li, int col, int vd, int hd, int d, IceSkater* p):RookieIceSkater(li, col, vd, hd, d, p)
{
    maxFalls = (rand() % 10)+1;
    cout << "Creating Kid -> id: " << id << "\tline: " << line << "\tcolumn: " << column << "\tspeed: " << speed << "\tdirection: " << direction << endl;     
}

ChildIceSkater::~ChildIceSkater()
{
    cout << "Destroying Kid -> id: " << id << "\tline: " << line << "\tcolumn: " << column << "\tspeed: " << speed << "\tdirection: " << direction << endl;     
    cout << "I want to stay longer...." << endl;
}

void ChildIceSkater::collision(IceSkater***& stage, int M, int L)
{ 
    cout << "Kid fell id: " << id << "\tline: " << line << "\tcolumn: " << column << "\tspeed: " << speed << "\tdirection: " << direction << endl;     
    cout << "Crying..." << endl; 
    
    maxFalls--;  
    if(maxFalls == 0)
        time = 0;
    
    int tmpl = line, tmpc = column;
    IceSkater* tempi = stage[line][column];     
    
    if(line == 0 && column == 0)
    {
        do
        {
            line = rand() % 2;
            column = rand() % 2;
        }while(line == 0 && column == 0);
    }
    else if(line == 0 && column == L)
    {
        do
        {
            line = rand() % 2;
            column = (rand() % 2) + L-1;
        }while(line == 0 && column == L);  
    }
    else if(line == M && column == L)
    {
        do
        {
            line = (rand() % 2) + M-1;
            column = (rand() % 2) + L-1;
        }while(line == M && column == L);        
    }
    else if(line == M && column == 0)
    {
        do
        {
            line = (rand() % 2) + M-1;
            column = rand() % 2;
        }while(line == M && column == 0);        
    }
    else if(column == 0)
    {
        int templ = line;
        do
        {
            line = (rand() % 3) + line - 1;
            column = rand() % 2;
        }while(line == templ && column == 0);       
    }
    else if(column == L)
    {
        int templ = line;
        do
        {
            line = (rand() % 3) + line - 1;
            column = (rand() % 2) + L - 1;
        }while(line == templ && column == L);       
    }
    else if(line == 0)
    {
        int tempc = column;
        do
        {
            line = rand() % 2;
            column = (rand() % 3) + column - 1;
        }while(line == 0 && column == tempc);        
    }
    else if(line == M)
    {
        int tempc = column;
        do
        {
            line = (rand() % 2) + M - 1;
            column = (rand() % 3) + column - 1;
        }while(line == M && column == tempc);          
    }
    else
    {
        int templ = line;
        int tempc = column;
        do
        {
            line = (rand() % 3) + line - 1;
            column = (rand() % 3) + column - 1;
        }while(line == templ && column == tempc);        
    }
    if(stage[line][column] != NULL)
    {
        if(stage[line][column]->hasMoved())
        {
            stage[line][column]->collision(stage, M, L);
            collision(stage, M, L);
        }
        else
        {
            stage[line][column]->skate(stage, M, L);
        } 
    }
    
    if(tempi != NULL)
        stage[line][column] = tempi;
    stage[tmpl][tmpc] = NULL;       
}

void ChildIceSkater::print()
{
    cout << " K ";    
}
