
#ifndef ICERINK_H
#define	ICERINK_H

#include "IceSkater.h"

class IceRink
{
public:
    
    IceRink(int, int, int, int); //constructor
    ~IceRink(); //destructor
    
    void simulate();
    
private:
    
    int M, L, N, T;
    IceSkater*** stage;

    void createStage();
    
    void createSkaters();
    
    void place(int&, int&, int&, int&, int&);
    
    int generateDirection(int, int);
    
    void printStageInfo();
};

#endif	/* ICERINK_H */

