
#include <iostream>
#include <cstdlib>
#include "RookieIceSkater.h"

using namespace std;

RookieIceSkater::RookieIceSkater(int li, int col, int vm, int hm, int d, IceSkater* p):IceSkater(li, col, 1, d, p)
{
    vermax = vm;
    hormax = hm;
    cout << "Creating Rookie -> id: " << id << "\tline: " << line << "\tcolumn: " << column << "\tspeed: " << speed << "\tdirection: " << direction << endl;     
}

RookieIceSkater::~RookieIceSkater()
{
    cout << "Destroying Rookie -> id: " << id << "\tline: " << line << "\tcolumn: " << column << "\tspeed: " << speed << "\tdirection: " << direction << endl; 
}

void RookieIceSkater::skate(IceSkater***& stage, int M, int L)
{
    cout << "Rookie skates" << endl;
    
    time--;    

    int tmpl = line, tmpc = column;
    IceSkater* tempi = stage[line][column];
    
    if(line > M/2 && column <= L/2)//vrisketai sto kato aristera tetartimorio
    {
        if(column == 0)
            direction = 0;
        else if(line == M && vermax == 0)
            direction = 6;       
        else if(line == M)
        {
            direction = rand() % 3;
            if(direction != 0)
                direction = direction + 5;
        }
        else if(line == M - vermax)
        {
            direction = (rand() % 3) + 4;   
        }
        else
            do{
                direction = rand() % 8;
            }while(direction > 0 && direction < 4);
        move();
    }

    else if(line <= M/2 && column <= L/2)//vrisketai sto pano aristera tetartimorio
    {
        if(line == 0)
            direction = 2;
        else if(column == 0 && hormax == 0)            
            direction = 0;        
        else if(column == 0)
            direction = rand() % 3;
        else if(column == hormax)
        {
            direction = rand() % 3;
            if(direction != 0)
                direction = direction + 5;            
        }
        else
            do{
                direction = rand() % 8;
            }while(direction > 2 && direction < 6);
        move();            
    }               

    else if(line <= M/2 && column > L/2)//vrisketai sto pano deksia tetartimorio
    {
        if(column == L)
            direction = 4;
        else if(line == 0 && vermax == 0)
            direction = 2;      
        else if(line == 0)
            direction = (rand() % 3) + 2;
        else if(line == vermax)
            direction = rand() % 3;       
        else
            do{
                direction = rand() % 8;
            }while(direction > 4);
        move();            
    }

    else if(line > M/2 && column > L/2)//vrisketai sto kato deksia tetartimorio
    {
        if(line == M)
            direction = 6;
        else if(column == L && hormax == 0)        
            direction = 4;                
        else if(column == L)
            direction = (rand() % 3) + 4;
        else if(column == L - hormax)
            direction = (rand() % 3) + 2;        
        else
            do{
                direction = rand() % 8;
            }while(direction > 6 && direction < 2);
        move();            
    }  
    
    if(stage[line][column] != NULL)
    {
        if(stage[line][column]->hasMoved())
        {
            stage[line][column]->collision(stage, M, L);
            collision(stage, M, L);
        }
        else
        {
            stage[line][column]->skate(stage, M, L);
        }               
    }     

    stage[line][column] = tempi;
    if(stage[tmpl][tmpc] == tempi)
    {
        stage[tmpl][tmpc] = NULL;
    }
    moved = true;    
}

void RookieIceSkater::move()
{
    switch (direction)
    {
        case 0:
            line--;             
            break;
        case 1:
            line--;column++;              
            break;
        case 2:
            column++;              
            break;
        case 3:
            line++;column++;               
            break;
        case 4:
            line++;              
            break;
        case 5:
            line++;column--;              
            break;
        case 6:
            column--;              
            break;
        case 7:
            line--;column--;              
            break;           
    }
}

void RookieIceSkater::collision(IceSkater***& stage, int M, int L)
{ 
    cout << "Rookie fell id: " << id << "\tline: " << line << "\tcolumn: " << column << "\tspeed: " << speed << "\tdirection: " << direction << endl;     
    cout << "I just fell but nice to meet you!" << endl;
    
    int tmpl = line, tmpc = column;
    IceSkater* tempi = stage[line][column];    
    
    if(line > M/2 && column <= L/2)//vrisketai sto kato aristera tetartimorio
    {
        if(column == 0)
            direction = 0;
        else if(line == M && vermax == 0)
            direction = 6;       
        else if(line == M)
        {
            direction = rand() % 3;
            if(direction != 0)
                direction = direction + 5;
        }
        else if(line == M - vermax)
        {
            direction = (rand() % 3) + 4;   
        }
        else
            do{
                direction = rand() % 8;
            }while(direction > 0 && direction < 4);
        move();
    }

    else if(line <= M/2 && column <= L/2)//vrisketai sto pano aristera tetartimorio
    {
        if(line == 0)
            direction = 2;
        else if(column == 0 && hormax == 0)            
            direction = 0;        
        else if(column == 0)
            direction = rand() % 3;
        else if(column == hormax)
        {
            direction = rand() % 3;
            if(direction != 0)
                direction = direction + 5;            
        }
        else
            do{
                direction = rand() % 8;
            }while(direction > 2 && direction < 6);
        move();            
    }               

    else if(line <= M/2 && column > L/2)//vrisketai sto pano deksia tetartimorio
    {
        if(column == L)
            direction = 4;
        else if(line == 0 && vermax == 0)
            direction = 2;      
        else if(line == 0)
            direction = (rand() % 3) + 2;
        else if(line == vermax)
            direction = rand() % 3;       
        else
            do{
                direction = rand() % 8;
            }while(direction > 4);
        move();            
    }

    else if(line > M/2 && column > L/2)//vrisketai sto kato deksia tetartimorio
    {
        if(line == M)
            direction = 6;
        else if(column == L && hormax == 0)        
            direction = 4;                
        else if(column == L)
            direction = (rand() % 3) + 4;
        else if(column == L - hormax)
            direction = (rand() % 3) + 2;        
        else
            do{
                direction = rand() % 8;
            }while(direction > 6 && direction < 2);
        move();            
    }  
    
    if(stage[line][column] != NULL)
    {
        if(stage[line][column]->hasMoved())
        {
            stage[line][column]->collision(stage, M, L);
            collision(stage, M, L);
        }
        else
        {
            stage[line][column]->skate(stage, M, L);
        } 
    }  
    
    if(tempi != NULL)
        stage[line][column] = tempi;
    stage[tmpl][tmpc] = NULL;       
}

void RookieIceSkater::print()
{
    cout << " R ";    
}